#!/bin/sh
# the next line restarts using the TCL interpreter \
exec tclsh "$0" ${1+"$@"}

#
# Copyright (C) 2022 Jonathan Certes
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program. If not, see <http://www.gnu.org/licenses/>.
#

##
# loading the shared library:
#
set dir [file dirname [file normalize [info script]]]
load "${dir}/example.so" example

##
# \brief
#   Traces the changes on a variable.
#
proc trace_variable {
  theVarName
  theArrayName
  theAction
} {
  if { ${theAction} == "write" } {
    puts "Variable ${theVarName} is now set to [set ::${theVarName}]"
  }
}

#===============================================================================

trace add variable myVariable write trace_variable

puts "myVariable = $myVariable"
myCommand
myCommand
set myVariable 4

